<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="/plantilla-principal.xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <f:metadata>
            <f:event type="preRenderView" listener="#{sessionManBean.modulosFuncionalidad(6)}"></f:event>
        </f:metadata>
        <style>
            #div-btn-elim{
                display: none;
            }
/*            div.scroll{
                height: 600px;
                overflow: auto;
            }*/
        </style>
        <h1>Modulos</h1>
        <div class="ui stackable grid">
            <div class="ten wide column">
                <div class="ui secondary menu">
                    <div class="fitted item">
                        <div id="boton-nuevo" class="ui green button">
                            <i class="file icon" />
                            Nuevo
                        </div>
                    </div>
                    <div id="div-btn-elim" class="fitted item">
                        <div class="ui red button">
                            <i class="trash icon"/>
                            Eliminar
                        </div>
                    </div>
                </div>
                <div class="ui fluid icon input search">
                    <input id="txtBuscar" placeholder="Buscar" type="text"></input>
                    <i class="search icon"></i>
                </div>
                <div class="scroll" id="scroll">
                    <h:form id="form-tabla">
                        <table jsf:id="elementos-tabla" class="ui selectable celled table">
                            <thead>
                                <tr>
                                    <th class="collapsing">
                                        <div  class="ui fitted checkbox" onclick="seleccionarTodo()">
                                            <input type="checkbox" id="chk-selec-todo"/>
                                            <label/>
                                        </div>
                                    </th>
                                    <th>ID</th>
                                    <th>Modulos</th>                                   
                                </tr>
                            </thead>
                            <tbody>

                                <ui:repeat value="#{moduloManbean.modulos}" var="modulos" varStatus="modulosStatus">
                                    <tr id="mod#{modulos.idmodulo}">
                                        <td  onclick="seleccionarFila('#{modulos.idmodulo}')"> 
                                            <div onclick="seleccionarCheck('#{modulos.idmodulo}')" class="ui fitted checkbox">
                                                <input id="chk-mod-#{modulos.idmodulo}" type="checkbox" />
                                                <label></label>
                                            </div>
                                        </td>
                                        <td width="25px" id="col-id-modulo-#{modulos.idmodulo}" onclick="seleccionarFila('#{modulos.idmodulo}')">#{modulos.idmodulo}</td>
                                        <td id="col-nombre-modulo-#{modulos.idmodulo}" onclick="seleccionarFila('#{modulos.idmodulo}')">#{modulos.nombre}</td>
                                    </tr>
                                </ui:repeat>
                            </tbody>
                        </table>
                    </h:form>
                </div>
            </div>
            <div class="six wide column">
                <h:form id="form-datos">
                    <div class="ui divider hidden"></div>
                    <div class="ui divider hidden"></div>
                    <div class="ui form">
                        <div class="field">
                            <label>ID</label>
                            <input disabled="true" jsf:id="idmodulo" name="idmodulo" jsf:value="#{moduloManbean.moduloVar.idmodulo}" placeholder="ID" type="number" readonly="true"></input>
                            <h:inputHidden id="idmod-hidden" value="#{moduloManbean.moduloVar.idmodulo}" />
                        </div>
                        <div id="nombreModulo" class="required field">
                            <label>Nombre</label>
                            <input jsf:id="nombremodulo" name="nombremodulo" jsf:value="#{moduloManbean.moduloVar.nombre}" placeholder="Nombre Modulo" type="text" required="true" autofocus="true"></input>
                        </div>
                    </div>
                    <div id="msg-formulario" class="ui info hidden message">
                        <i class="close icon" />
                        <div class="header">
                            Info
                        </div>
                        <h:outputText id="text-formulario" value="#{moduloManbean.msg}"/>
                    </div>
                    <!--</div>-->
                    <p/>
                    <p/>
                    <div class="actions">
                        <h:commandLink rendered="#{sessionManBean.permisosAsignados(11)}" id="btn-modif" class="ui teal button" onclick="validarCampos()" action="#{moduloManbean.modificarModulo()}">
                            <i class="save icon" />
                            Guardar
                            <f:ajax execute="@form" onevent="function (data) {
                            if (data.status == 'success') {
                            if ($('#msg-formulario').css('display') == 'none') {
                            $('#msg-formulario').transition('fade');
                            }
                            }
                            }" 
                            render="text-formulario form-tabla"/>
                        </h:commandLink>
                        <h:commandLink rendered="#{sessionManBean.permisosAsignados(10)}" id="btn-agre" class="ui primary button" onclick="validarCampos()" action="#{moduloManbean.registrarModulos()}">
                            <i class="add circle icon" />
                            Agregar
                            <f:ajax execute="@form" onevent="function (data) {
                            if (data.status == 'success') {
                            if ($('#msg-formulario').css('display') == 'none') {
                            $('#msg-formulario').transition('fade');
                            }
                            }
                            }" 
                            render="text-formulario form-tabla"/>
                        </h:commandLink>
                    </div>
                </h:form>
                
                <h:form rendered="#{sessionManBean.permisosAsignados(12)}" id="dlg-conf-elim" class="ui basic modal">
                    <input name="selbar" id="selbar" type="hidden" jsf:value="#{moduloManbean.seleccionarIDmoduloJSON}"/>
            <div class="ui icon header">
                <i class="trash icon"></i>
                Eliminar categoria cliente
            </div>
            <div class="centered content">
                <p>¿Desea eliminar los elementos seleccionados?</p>
            </div>
            <div class="actions">
                <h:commandLink rendered="#{sessionManBean.permisosAsignados(12)}" action="#{moduloManbean.eliminarModulo()}" class="ui green ok inverted button">
                    <i class="checkmark icon"></i>
                    Sí
                    <f:ajax execute="@form" onevent="generarDatos()" render="form-tabla"/>
                </h:commandLink>

                <div class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    No
                </div>
            </div>
        </h:form>
                
            </div>
        </div>
        <script>
            $('#form-datos\\:btn-modif').hide();
            $("#boton-nuevo").click(function (){
                $('#form-datos\\:btn-agre').show();
                $('#form-datos\\:btn-modif').hide();
                $('#form-datos\\:nombremodulo').focus();
                limpiarFormulario();
                removerCampoError();
            });
            
            $('#form-datos\\:btn-agre').click(function (){
                $('#form-datos\\:nombremodulo').focus();
                limpiarFormulario();
            });
            
            $('#form-datos\\:btn-modif').click(function  (){
                $('#form-datos\\:nombremodulo').focus();
                $('#form-datos\\:btn-modif').hide();
                $('#form-datos\\:btn-agre').show();
                $('#div-btn-elim').hide();
                limpiarFormulario();
            });
            
            $('#div-btn-elim').click(function () {
                $('#dlg-conf-elim').modal('show');
            });
            
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });
            
            function comprobarSeleccionTodo(){
                var seleccionados = $('tbody :checkbox:checked').length;
                var cantfila = $("tbody tr").length;
                if(seleccionados === 0){
                    $("#chk-selec-todo").prop("checked", false);
                }else{
                    if(seleccionados===cantfila){
                        $("#chk-selec-todo").prop("checked", true);
                    }else{
                        $("#chk-selec-todo").prop("checked", false);
                    }
                }
            }
            
            function ocultarBtnEliminarAndModifcar(){
                var seleccionado =$("tbody :checkbox:checked").length;
                if (seleccionado > 0) {
                    $("#div-btn-elim").show();
                    if (seleccionado===1) {
                        $('#form-datos\\:btn-modif').show();
                        $('#form-datos\\:btn-agre').hide();
                    }else{
                       $('#form-datos\\:btn-modif').hide();
                       $('#form-datos\\:btn-agre').show();
                    }
                }else{
                    $("#div-btn-elim").hide();
                    $('#form-datos\\:btn-modif').hide();
                    $('#form-datos\\:btn-agre').show();
                }
            }
            
            function seleccionarFila(idmodulo){
                var idfila = '#mod' + idmodulo;
                var idchk = '#chk-mod-' + idmodulo;
                if($(idfila).hasClass('active')){
                    $(idfila).removeClass('active');
                    $(idchk).prop('checked', false);
                    limpiarFormulario();
                }else {
                    $(idfila).addClass('active');
                    $(idchk).prop('checked', true);
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificar(idmodulo);
                removerCampoError();
            }
            
            function seleccionarCheck(idmodulo){
                var idchk = '#chk-mod-' + idmodulo;
                var idfila = '#mod' + idmodulo;
                if($(idchk).prop('checked')){
                    $(idfila).removeClass("active");
                    limpiarFormulario();
                }else {
                    $(idfila).addClass('active');
                    $('#form-datos\\:nombremodulo').focus();
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificar(idmodulo);
                removerCampoError();
            }
            
            function seleccionarTodo(){
                if ($("#chk-selec-todo").prop("checked")) {
                    $("tbody tr").addClass("active");
                    $("tbody :checkbox").prop("checked", true);
                    $('#form-datos\\:btn-modif').hide();
                } else{
                    $("tbody tr").removeClass("active");
                    $("tbody :checkbox").prop("checked", false);
                    limpiarFormulario();
                }
                ocultarBtnEliminarAndModifcar();
            }
            
            function modificar(idmodulo){
                $('#form-datos\\:idmodulo').val($('#col-id-modulo-'+idmodulo).html());
                $('#form-datos\\:idmod-hidden').val($('#col-id-modulo-'+idmodulo).html());
                $('#form-datos\\:nombremodulo').val($('#col-nombre-modulo-'+idmodulo).html());
            }
            
            function generarDatos(){
                var idSeleccionados=[];
                $("tbody tr [id^='col-id-modulo']").each(function (index, value){
                   var id = parseInt($(this).html());
                   
                   if($('#chk-mod-'+id).prop('checked')){
                       idSeleccionados.push(id);
                   }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar').val(jsonselect);
                $('#div-btn-elim').hide();
            }
            
            $(document).ready(function(){
                $("#txtBuscar").keyup(function(){
                    if( $(this).val() !== ""){
			$("#form-tabla\\:elementos-tabla tbody>tr").hide();
			$("#form-tabla\\:elementos-tabla td:contains-ci('" + $(this).val() + "')").parent("tr").show();
                    }else{
			$("#form-tabla\\:elementos-tabla tbody>tr").show();
                    }
                });
            });
            $.extend($.expr[":"],{
                "contains-ci": function(elem, i, match, array){
                    return (elem.textContent || elem.innerText || $(elem).text() || "").toLowerCase().indexOf((match[3] || "").toLowerCase()) >= 0;
                }
            });
            
             function limpiarFormulario(){
                $('#form-datos\\:idmodulo').val($().html());
                $('#form-datos\\:idmod-hidden').val($().html());
                $('#form-datos\\:nombremodulo').val($().html());
                $('#form-datos\\:nombremodulo').focus();
            }
            
            function validarCampos(){
                var nombre = $('#form-datos\\:nombremodulo').val();
                if(nombre===""){
                    $('#nombreModulo').addClass('error');
                }else {
                    $('#nombreModulo').removeClass('error');
                }
            }
            function removerCampoError(){
                $('#nombreModulo').removeClass('error');
            }
        </script>
    </ui:define>
</ui:composition>